/*-----------------------------------------------------------------------*/
/* filename -       tdemo2.hpp                                           */
/*                                                                       */
/* function(s)                                                           */
/*                  declarations for the following classes used in the   */
/*                  TVColorDialog demo program...                        */
/*                                                                       */
/*                     TXDialog1                                         */
/*                     TXDialog2                                         */
/*                     TXDialog3                                         */
/*                     TAppStatusLine                                    */
/*                                                                       */
/* Author -         Michael "Mick" Newton                                */
/*                                                                       */
/*-----------------------------------------------------------------------*/

/*-----------------------------------------------------------------------*/
/*                                                                       */
/*    TDEMO2.HPP                                                         */
/*                                                                       */
/*    TVColorDialog shareware version 2.0                                */
/*    (C) Copyright 1992,1993 Comsoft Software                           */
/*    All Rights Reserved.                                               */
/*                                                                       */
/*                                                                       */
/*-----------------------------------------------------------------------*/


#if !defined __TDEMO2_HPP
#define __TDEMO2_HPP


// Forward references to Turbo Vision classes *****************************

class far TDialog;
class far TListBox;
class far TRect;
class far TPalette;
class far TStatusDef;
class far TStatusLine;





// Constants **************************************************************

const cmCloseX = 200;

// Help contexts for status line hints
const hcSystem     = 1000,
      hcAbout      = 1001,
      hcWritePal   = 1002,
      hcExit       = 1003,
      hcColors     = 1004,
      hcOptions    = 1005,
      hcXDialogs   = 1006;





// TXDialog1 **************************************************************

class TXDialog1 : public TDialog
{
   public:
      TXDialog1(const TRect& bounds, const char *aTitle);
      virtual void shutDown();
      virtual TPalette& getPalette() const;
      virtual void handleEvent(TEvent& event);
      TListBox *listbox;
   protected:
   private:
};





// TXDialog2 **************************************************************

class TXDialog2 : public TDialog
{
   public:
      TXDialog2(const TRect& bounds, const char *aTitle);
      virtual void shutDown();
      virtual TPalette& getPalette() const;
      virtual void handleEvent(TEvent& event);
      TListBox *listbox;
   protected:
   private:
};





// TXDialog3 **************************************************************

class TXDialog3 : public TDialog
{
   public:
      TXDialog3(const TRect& bounds, const char *aTitle);
      virtual void shutDown();
      virtual TPalette& getPalette() const;
      virtual void handleEvent(TEvent& event);
      TListBox *listbox;
   protected:
   private:
};





// TAppStatusLine *********************************************************

class TAppStatusLine : public TStatusLine
{
   public:
      TAppStatusLine(const TRect& bounds, TStatusDef& aDefs);
      virtual TPalette& getPalette() const;
      virtual const char *hint(ushort aHelpCtx);
   protected:
   private:
};


#endif

//                                End of TDEMO2.HPP



